﻿using System;
using Core.Models;
using System.Collections.Generic;
namespace Core.Logic
{
  public interface IUserAccountAction<T>
  {
    IUserAccountSqlAzureAction SqlAzureAction { get; set; }
    IUserAccountStorageAction StorageAction { get; set; }
    
    void CreateUserAccount(T userAccount);

    List<T> GetUserAccounts(Guid userId);

    double GetAccountBalance(Guid userId, Guid accountId);

    T GetUserAccount(Guid userId, Guid accountId);

    TransactionResponse InsertMoney(Guid userId, Guid accountId, 
                                    Guid transactionId, double amount);

    TransactionResponse WithDrawMoney(Guid userId, Guid accountId, 
                                      Guid transactionId, double amount);

    TransactionResponse ReliableInsertMoney(Guid userId, Guid accountId, 
                                            Guid transactionId, double amount, 
                                            bool serializeToQueue);

    TransactionResponse ReliableWithDrawMoney(Guid userId, Guid accountId, 
                                              Guid transactionId, double amount, 
                                              bool serializeToQueue);
  }
}
