﻿using System;
using Core.TableStorage;
using Core.Models;
namespace Core.Logic
{
  public interface IUserAccountStorageAction
  {
    void CreateUserAccount(UserAccountBalance userAccountTransaction);
  
    double GetAccountBalance(Guid userId, Guid accountId);
    
    TransactionResponse InsertOrRedrawMoneyWithTableStorage(UserAccountTransaction accountTransaction);

    void LoggTransactionToTableStorage(AccountTransactionLog msg);
    
    TransactionResponse ReliableHandleMoneyInQueue(UserAccountTransaction accountTransaction);
    
    TransactionResponse ReliableHandleMoneyInQueueAsXml(UserAccountTransaction accountTransaction);
    
    void DeleteUserAccount(Guid userId, Guid accountId);
  }
}
