﻿using System;
using System.Runtime.Serialization;

namespace Core.Models
{
  [DataContract]
  public class User : IExtensibleDataObject
  {
    [DataMember(IsRequired = true)]
    public Guid UserId { get; set; }

    [DataMember(IsRequired = true)]
    public string FirstName { get; set; }

    [DataMember(IsRequired = true)]
    public string LastName { get; set; }

    [DataMember(IsRequired = true)]
    public string Address { get; set; }

    [DataMember(IsRequired = true)]
    public string PhoneNumber { get; set; }

    [DataMember(IsRequired = false)]
    public string SocSecNumber { get; set; }

    private ExtensionDataObject _extensionData;

    public ExtensionDataObject ExtensionData
    {
      get{return this._extensionData;}
      set{this._extensionData = value;}
    }

    public User(Guid userId)
    {
      this.UserId = userId;
    }
    public User()
    { }
  }
}
