﻿using System;
using System.Runtime.Serialization;
using Core.Types;

namespace Core.Models
{
  /// <summary>
  /// Base type which is saved to DB known by service
  /// </summary>
  [DataContract]
  public class UserAccount : IExtensibleDataObject
  {
    [DataMember(IsRequired = true)]
    public Guid AccountId { get; set; }
    
    [DataMember(IsRequired = false)]
    public AccountStatus UserAccountStatus { get; set; }
    
    [DataMember(IsRequired = false)]
    public AccountType UserAccountType { get; set; }
    
    [DataMember(IsRequired = true)]
    public double Balance { get; set; }
    
    [DataMember(IsRequired = true)]
    public string Currency { get; set; }
    
    [DataMember(IsRequired = true)]
    public string CreditCardNumber { get; set; }
    
    [DataMember(IsRequired = false)]
    public string Description { get; set; }
    
    [DataMember(IsRequired = false)]
    public string Country { get; set; }
    
    [DataMember(IsRequired = false)]
    public Int32 BankIdentifier { get; set; }
    
    [DataMember(IsRequired = false)]
    public byte[] UpdateTag { get; set; }
    
    [DataMember(IsRequired = false)]
    public Guid UserId { get; set; }

    private ExtensionDataObject _extensionData;
    public ExtensionDataObject ExtensionData
    {
      get
      {return this._extensionData;}
      set
      {this._extensionData = value;}
    }
    public UserAccount()
    {
    }
  }
}
