﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;
using Core.Types;

namespace Core.Models
{
  /// <summary>
  ///bankaccount number is country|bankidentifier|accountid|currency
  ///insert into tabel column called bank account number this transformed string
  ///when replying transform message by transforming string from db column and adding to 
  ///properties of this class 
  /// </summary>
  [DataContract]
  public class UserAccountAdvanced : IExtensibleDataObject
  {

    [DataMember(IsRequired = true)]
    public Guid UserId { get; set; }

    [DataMember(IsRequired = true)]
    public double Balance { get; set; }

    [DataMember(IsRequired = true)]
    public string CreditCardNumber { get; set; }

    [DataMember(IsRequired = true)]
    public string BankAccountNumber { get; set; }

    [DataMember(IsRequired = false)]
    public AccountType UserAccountType { get; set; }

    [DataMember(IsRequired = false)]
    public AccountStatus UserAccountStatus { get; set; }

    private ExtensionDataObject _extensionData;
    public ExtensionDataObject ExtensionData
    {
      get{return this._extensionData;}
      set{this._extensionData = value;}
    }
    [OnDeserializing()]
    internal void OnDeserializing(StreamingContext context)
    {
      UserAccountType = AccountType.Advanced;
    }

    public UserAccountAdvanced()
    {
    
    }

  }
}
