﻿using System;
using System.ServiceModel;
using System.ServiceModel.Web;

namespace Core.Services
{
  [ServiceContract]
  public interface IAccountServiceAdvanced : IAccountServiceBase
  {
    [OperationContract]
    void CreateAccount(Core.Models.UserAccountAdvanced userAccount);

    [OperationContract]
    Core.Models.UserAccountAdvanced GetUserAccount(Guid userId, Guid accountId);

    [OperationContract]
    Core.Models.UserAccountAdvanced[] GetUserAccounts(Guid userId);
  }
  [ServiceContract]
  public interface IAccountServiceAdvancedRest : IAccountServiceBaseRest
  {
    [OperationContract]
    [WebInvoke(Method = "PUT", BodyStyle = WebMessageBodyStyle.Bare, ResponseFormat = WebMessageFormat.Xml)]
    void CreateAccount(Core.Models.UserAccountAdvanced userAccount);

    [OperationContract]
    [WebGet(UriTemplate = "accounts/{userId}/{accountId}")]
    Core.Models.UserAccountAdvanced GetUserAccount(Guid userId, Guid accountId);

    [OperationContract]
    [WebGet(UriTemplate="accounts/{userId}")]
    Core.Models.UserAccountAdvanced[] GetUserAccounts(Guid userId);
  }

}
