﻿using System;
using System.ServiceModel;
using System.ServiceModel.Web;

namespace Core.Services
{
  [ServiceContract]
  public interface IAccountServiceNormal : IAccountServiceBase
  {
    [OperationContract]
    void CreateAccount(Core.Models.UserAccountWwi userAccount);

    [OperationContract]
    Core.Models.UserAccountWwi GetUserAccount(Guid userId, Guid accountId);

    [OperationContract]
    Core.Models.UserAccountWwi[] GetUserAccounts(Guid userId);
  }
  [ServiceContract]
  public interface IAccountServiceNormalRest : IAccountServiceBaseRest
  {
    [OperationContract]
    [WebInvoke(Method = "PUT", BodyStyle = WebMessageBodyStyle.Bare, ResponseFormat = WebMessageFormat.Xml)]
    void CreateAccount(Core.Models.UserAccountWwi userAccount);

    [OperationContract]
    [WebGet(UriTemplate = "accounts/{userId}/{accountId}")]
    Core.Models.UserAccountWwi GetUserAccount(string userId, string accountId);

    [OperationContract]
    [WebGet(UriTemplate="accounts/{userId}")]
    Core.Models.UserAccountWwi[] GetUserAccounts(string userId);
  }
}
