﻿using System;
using System.ServiceModel;
using System.ServiceModel.Web;

namespace Core.Services
{
  [ServiceContract]
  public interface IUserBankService
  {
    [OperationContract]
    void CreateUser(Core.Models.User user);
    [OperationContract]
    Core.Models.User GetUser(Guid userId);

    [OperationContract]
    void ModifyUser(Core.Models.User modifiedUser);

    [OperationContract]
    void DeleteUser(Guid userId);
  }

  [ServiceContract]
  public interface IUserBankServiceRest
  {
    [OperationContract]
    [WebInvoke(Method = "PUT", BodyStyle = WebMessageBodyStyle.Bare, ResponseFormat = WebMessageFormat.Xml)]
    void CreateUser(Core.Models.User user);

    [OperationContract]
    [WebGet(UriTemplate="users/{userId}")]
    Core.Models.User GetUser(string userId);

    [OperationContract]
    [WebInvoke(Method = "POST")]
    void ModifyUser(Core.Models.User modifiedUser);

    [OperationContract]
    [WebInvoke(Method = "DELETE")]
    void DeleteUser(Guid userId);
  }
}
