﻿using System;
using System.ComponentModel;
using Microsoft.WindowsAzure.StorageClient;

namespace Core.TableStorage
{
  [Description("PartitionKey=UserId|AccountId, Rowkey=TransactionDate")]
  public class AccountTransactionLog : TableServiceEntity
  {
    public string Message { get; set; }
    /// <summary>
    /// Initializes a new instance of the <see cref="UserAccountTransactionTable"/> class.
    /// </summary>
    public AccountTransactionLog()
      : base(String.Format("{0}|{1}", Guid.NewGuid().ToString(), Guid.NewGuid().ToString()),
        DateTime.UtcNow.ToString("yyyy MM dd hh:mm:ss.fffffff"))
    {
    }
    public AccountTransactionLog(Guid userId, Guid accountId)
      : base(String.Format("{0}|{1}", userId.ToString(), accountId.ToString()),
        DateTime.UtcNow.ToString("yyyy MM dd hh:mm:ss.fffffff"))
    {
    }
    public AccountTransactionLog(string userId, string accountId)
      : base(String.Format("{0}|{1}", userId, accountId),
        DateTime.UtcNow.ToString("yyyy MM dd hh:mm:ss.fffffff"))
    {
    }
  }
}
