﻿using System;
using Microsoft.WindowsAzure.StorageClient;
using System.ComponentModel;

namespace Core.TableStorage
{
  [Description("PartitionKey=UserId|AccountId, Rowkey=TransactionId")]
  public class UserAccountTransaction : TableServiceEntity
  {
    /// <summary>
    /// Gets or sets the amount.
    /// </summary>
    /// <value>The amount.</value>
    public double Amount { get; set; }
    /// <summary>
    /// Gets or sets the message.
    /// </summary>
    /// <value>The message.</value>
    public string Message { get; set; }
    /// <summary>
    /// Initializes a new instance of the <see cref="UserAccountTransactionTable"/> class.
    /// </summary>
    public UserAccountTransaction()
      : base(String.Format("{0}|{1}", Guid.NewGuid().ToString(), 
      Guid.NewGuid().ToString()), Guid.NewGuid().ToString())
    {
    }
    public UserAccountTransaction(Guid userId, Guid accountId)
      : base(String.Format("{0}|{1}", userId.ToString(), accountId.ToString()), 
      Guid.NewGuid().ToString())
    {
    }
    public UserAccountTransaction(Guid userId, Guid accountId, Guid transactionId)
      : base(String.Format("{0}|{1}", userId.ToString(), accountId.ToString()), 
      transactionId.ToString())
    {
    }
    public UserAccountTransaction(string userId, string accountId, string transactionId)
      : base(String.Format("{0}|{1}", userId, accountId), 
      transactionId)
    {
    }
  }
}
