﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.WindowsAzure.StorageClient;
using Microsoft.WindowsAzure;
namespace Core.Queues
{
  public class QueueManager
  {
    private static CloudQueue _loggQueue;
    private static CloudQueue _accountTransQueue;
    private static CloudQueueClient _queueClient;
    
    private static bool _initDone = false;

    public static CloudQueue AccountTransactionsQueue
    {
      get
      {
        InitQueues();
        return _accountTransQueue;
      }
    }
    public static CloudQueue AccountTransactionsLoggQueue
    {
      get
      {
        InitQueues();
        return _loggQueue;
      }
    }
    public static CloudQueueClient CreateQueueStorage()
    {
      CloudQueueClient queueClient = 
        CloudStorageAccount.FromConfigurationSetting("DataConnectionString").CreateCloudQueueClient();
      
      return queueClient;
    }

    private static void InitQueues()
    {
      if (!_initDone)
      {
        _queueClient = CreateQueueStorage();

        _accountTransQueue = _queueClient.GetQueueReference(Core.Helpers.Queues.AccountTransactionsQueue);
        _accountTransQueue.CreateIfNotExist();

        _loggQueue = _queueClient.GetQueueReference(Core.Helpers.Queues.AccountTransactionLoggQueue);
        _loggQueue.CreateIfNotExist();

        _initDone = true;
      }
    }


  }
}
