﻿using Microsoft.Practices.EnterpriseLibrary.Data;

namespace Core.DataAccess
{
  public abstract class DBBase
  {
    private Database _db = null;
    public Database DB
    {
      get
      {
        if (_db == null)
          _db = DatabaseFactory.CreateDatabase(this.ConnectionString);
        return _db;
      }
    }
    private string ConnectionString
    {
      get;
      set;
    }
    public DBBase(string connectionString)
    {
      if (connectionString != string.Empty)
        this.ConnectionString = connectionString;
      else
        //should be another type of exception here
        throw new System.Exception("DBLayer.Resources.DBException.ConnectionStringEmpty");
    }
  }
}
