﻿using System;
using Core.Helpers;
using System.Data;

namespace Core.DataAccess
{
  public class UserDB : DBBase, IUserDB
  {
    public UserDB(string connectionString)
      : base(connectionString)
    { }

   
    /// <summary>
    /// Creates the user.
    /// </summary>
    /// <param name="user">The user.</param>
    public void CreateUser(Core.Models.User user)
    {
      //Validate inarguments
      using (System.Data.Common.DbCommand cmd = DB.GetStoredProcCommand(StoredProcedures.CREATENEWUSER,
        new object[] { user.UserId, user.FirstName, user.LastName, user.Address, user.SocSecNumber, user.PhoneNumber }))
      {
        DB.ExecuteNonQuery(cmd);
      }

    }
    /// <summary>
    /// Gets the user by user id.
    /// </summary>
    /// <param name="userId">The user id.</param>
    /// <returns></returns>
    public Core.Models.User GetUserByUserId(Guid userId)
    {
      try
      {
        Core.Models.User user = null;
        using (System.Data.Common.DbCommand cmd = 
          DB.GetStoredProcCommand(StoredProcedures.GETUSERBYID, new object[] { userId }))
        {
          using (IDataReader dr = DB.ExecuteReader(cmd))
          {
            if(dr.Read())
            {
              user = new Core.Models.User(userId)
              {
                FirstName = (dr.IsDBNull(0) ? string.Empty : dr[0].ToString()),
                LastName = (dr.IsDBNull(1) ? string.Empty : dr[1].ToString()),
                Address = (dr.IsDBNull(2) ? string.Empty : dr[2].ToString()),
                SocSecNumber = (dr.IsDBNull(3) ? string.Empty : dr[3].ToString()),
                PhoneNumber = (dr.IsDBNull(4) ? string.Empty : dr[4].ToString()),
              };
            }
          }
        }
        return user;
      }
      catch
      { throw; }
    }
  }
}
