﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel;

namespace Core.Services
{
  [ServiceBehavior(AddressFilterMode = AddressFilterMode.Any)]
  public class UserBankService:IUserBankService
  {
    Core.Logic.IUserAction UserAction {get;set;}
    public UserBankService()
    {
      //TODO: Replace this with Unity in config file.
      UserAction = new Core.Logic.UserAction(new Core.DataAccess.UserDB("ConnStr"));
    }
    public UserBankService(Core.Logic.IUserAction userAction)
    {
      UserAction = userAction;
    }
    #region IUserBankService Members

    public void CreateUser(Core.Models.User user)
    {
      
      UserAction.CreateUser(user);
    }

    public Core.Models.User GetUser(Guid userId)
    {
      return UserAction.GetUserByUserId(userId);
    }

    public void ModifyUser(Core.Models.User modifiedUser)
    {
      throw new NotImplementedException();
    }

    public void DeleteUser(Guid userId)
    {
      throw new NotImplementedException();
    }

    #endregion
  }


  public class UserBankServiceRest : IUserBankServiceRest
  {
    Core.Logic.IUserAction UserAction { get; set; }
    #region IUserBankServiceRest Members
    public UserBankServiceRest()
    {
      //TODO: Replace this with Unity in config file.
      UserAction = new Core.Logic.UserAction(new Core.DataAccess.UserDB("ConnStr"));
    }

    public void CreateUser(Core.Models.User user)
    {
      UserAction.CreateUser(user);
    }

    public Core.Models.User GetUser(string userId)
    {
      return UserAction.GetUserByUserId(new Guid(userId));
    }

    public void ModifyUser(Core.Models.User modifiedUser)
    {
      throw new NotImplementedException();
    }

    public void DeleteUser(Guid userId)
    {
      throw new NotImplementedException();
    }

    #endregion
  }
}
